Subject: [PATCH 0/3] Add image-type support.

From: Mathieu Othacehe <[email-masked]>
Date: Fri, 31 Jul 2020 16:48:25 +0200

Hello,

This is the missing piece for the new image API. It has been previously
discussed here[1].

I think this is close to what Ludo suggested and it addresses janneke concerns
about composability.

The idea is to introduce the concept of "image-type". An image type is a
converter from an <operating-system> record to an <image> record.

I have created in this serie 4 new image type records:
- raw
- iso9660
- uncompressed-iso9660
- hurd-raw

I also adapted the "guix system" command by removing the "file-system-type"
argument and replaced it by the "image-type" argument.

The default is still to create a raw disk-image, but one can now call:

guix system disk-image -t iso9660 my-config.scm
guix system disk-image -t uncompressed-iso9660 my-config.scm
guix system disk-image -t hurd-raw my-config.scm

and so on. Maybe we should also rename "disk-image" command to "image" that
would be somehow more accurate.

The only missing bit is the documentation update, as I prefer to wait for this
change to be approved first.

WDYT?

Thanks,

Mathieu

[1]: https://lists.gnu.org/archive/html/guix-devel/2020-05/msg00417.html

Mathieu Othacehe (3):
  image: Add image-type support.
  system: image: Add image-type support.
  scripts: system: Add support for image-type.

 gnu/image.scm              | 29 ++++++++++++++-
 gnu/system/image.scm       | 75 ++++++++++++++++++++++++++++++++++++--
 gnu/system/images/hurd.scm | 13 +++++--
 guix/scripts/system.scm    | 56 +++++++++++++++++-----------
 4 files changed, 145 insertions(+), 28 deletions(-)

-- 
2.26.2